%global momorel 2
%global _localstatedir /var/run
%global _libexecdir /usr/libexec/courier-imap

Summary: Courier-IMAP IMAP server
Name: courier-imap
Version: 3.0.7
Release: %{momorel}m
License: GPL
Source0: http://heanet.dl.sourceforge.net/sourceforge/courier/%{name}-%{version}.tar.bz2
NoSource: 0
URL: http://www.courier-mta.org/imap/
Group: System Environment/Daemons
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Conflicts: imap

Patch0: courier-imap-1.3.11-mkimapdcert.patch
Patch1: courier-imap-1.3.11-mkpop3dcert.patch
Patch2: courier-imap-3.0.5-sysvinit.patch

Patch100: courier-imap-gcc31.patch

PreReq: chkconfig
PreReq: bash
PreReq: sh-utils
PreReq: perl

Requires: gdbm
Requires: openssl 
Requires: pam
Requires: fileutils
Requires: textutils
Requires: sed
Requires: fam

BuildPrereq: MySQL-devel
BuildPrereq: cyrus-sasl-devel
BuildPrereq: gdbm-devel
BuildPrereq: openldap-devel >= 2.1.22-2m
BuildPrereq: openssl-devel
BuildPrereq: pam-devel
BuildPrereq: postgresql-devel
BuildPrereq: zlib-devel >= 1.1.4-5m
BuildPrereq: fileutils
BuildPrereq: textutils
BuildPrereq: sed
BuildPrereq: perl
BuildRequires: momonga-rpmmacros >= 20040310-6m

%description
Courier-IMAP is an IMAP server for Maildir mailboxes.  This package contains
the standalone version of the IMAP server that's included in the Courier
mail server package.  This package is a standalone version for use with
other mail servers.  Do not install this package if you intend to install the
full Courier mail server.  Install the Courier package instead.

%package ldap
Summary: Courier-IMAP LDAP authentication driver.
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}
Requires: cyrus-sasl
Requires: gdbm
Requires: openldap
Requires: openssl
Requires: pam

%description ldap
This package contains the necessary files to allow Courier-IMAP to
authenticate from an LDAP directory.  Install this package if you need
the ability to use an LDAP directory for authentication.

%package mysql
Summary: Courier-IMAP MySQL authentication driver.
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}
Requires: MySQL-shared-libs
Requires: gdbm
Requires: pam
Requires: zlib >= 1.1.4-5m

%description mysql
This package contains the necessary files to allow Courier-IMAP to
authenticate using a MySQL database table.  Install this package if you need
the ability to use a MySQL database table for authentication.

%package pgsql
Summary: Courier-IMAP PostgreSQL authentication driver.
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}
Requires: gdbm
Requires: pam
Requires: postgresql
Requires: openssl

%description pgsql
This package contains the necessary files to allow Courier-IMAP to
authenticate using a PostgreSQL database table.  Install this package if you
need the ability to use a PostgreSQL database table for authentication.

%prep

%setup -q 0

%patch0 -b .mkimapdcert
%patch1 -b .mkpop3dcert
%patch2 -p1 -b .sysvinit

%patch100 -p1 -b .gcc3

cp -f imap/README README.imap
cp -f maildir/README.maildirquota.txt README.maildirquota
cp -f maildir/README.sharedfolders.txt README.sharedfolders

perl -p -i -e "s,^version=.*,version=authdaemond.plain," authlib/authdaemonrc.in

%build

./configure \
	--prefix=%{_prefix} \
	--exec-prefix=%{_exec_prefix} \
	--bindir=%{_bindir} \
	--sbindir=%{_sbindir} \
	--libexecdir=%{_libexecdir} \
	--datadir=%{_datadir}/courier-imap \
	--sysconfdir=%{_sysconfdir}/courier-imap \
	--sharedstatedir=%{_sharedstatedir} \
	--localstatedir=%{_localstatedir} \
	--libdir=%{_libdir} \
	--includedir=%{_includedir} \
	--infodir=%{_infodir} \
	--mandir=%{_mandir} \
%if ! %{_ipv6}
	--without-ipv6 \
%endif
	--with-userdb=%{_sysconfdir}/courier-imap/userdb \
	--with-authdaemonvar=%{_localstatedir}/authdaemon.courier-imap \
	--with-authchangepwdir=%{_libexecdir}/authlib \
	--without-authvchkpw \
	--with-mailuser=root \
	--with-db=gdbm \
	--enable-unicode=iso-8859-1,us-ascii,utf-8,iso-2022-jp \
	--with-redhat

make %{?_smp_mflags} || make
make check

%install

rm -rf %{buildroot}

install -d %{buildroot}%{_sysconfdir}/pam.d
install -d %{buildroot}%{_initscriptdir}

make install-strip DESTDIR=%{buildroot}

# Red Hat init.d file...
install -m 755 courier-imap.sysvinit %{buildroot}%{_initscriptdir}/courier-imap

# Fix imapd.dist...

sed 's/^IMAPDSTART=.*/IMAPDSTART=YES/' \
	<%{buildroot}%{_sysconfdir}/courier-imap/imapd.dist \
	>%{buildroot}%{_sysconfdir}/courier-imap/imapd.dist.tmp

mv %{buildroot}%{_sysconfdir}/courier-imap/imapd.dist.tmp \
	%{buildroot}%{_sysconfdir}/courier-imap/imapd.dist

sed 's/^IMAPDSSLSTART=.*/IMAPDSSLSTART=YES/' \
	<%{buildroot}%{_sysconfdir}/courier-imap/imapd-ssl.dist \
	>%{buildroot}%{_sysconfdir}/courier-imap/imapd-ssl.dist.tmp

mv %{buildroot}%{_sysconfdir}/courier-imap/imapd-ssl.dist.tmp \
        %{buildroot}%{_sysconfdir}/courier-imap/imapd-ssl.dist

sed 's/^TLS_CERTFILE=.*/TLS_CERTFILE=\/etc\/courier-imap\/imapd.pem/' \
        <%{buildroot}%{_sysconfdir}/courier-imap/imapd-ssl.dist \
        >%{buildroot}%{_sysconfdir}/courier-imap/imapd-ssl.dist.tmp

mv %{buildroot}%{_sysconfdir}/courier-imap/imapd-ssl.dist.tmp \
	%{buildroot}%{_sysconfdir}/courier-imap/imapd-ssl.dist

chmod 600 %{buildroot}%{_sysconfdir}/courier-imap/imapd.dist
chmod 600 %{buildroot}%{_sysconfdir}/courier-imap/imapd-ssl.dist

sed 's/^POP3DSTART=.*/POP3DSTART=YES/' \
	<%{buildroot}%{_sysconfdir}/courier-imap/pop3d.dist \
	>%{buildroot}%{_sysconfdir}/courier-imap/pop3d.dist.tmp

mv %{buildroot}%{_sysconfdir}/courier-imap/pop3d.dist.tmp \
	%{buildroot}%{_sysconfdir}/courier-imap/pop3d.dist

sed 's/^POP3DSSLSTART=.*/POP3DSSLSTART=YES/' \
	<%{buildroot}%{_sysconfdir}/courier-imap/pop3d-ssl.dist \
	>%{buildroot}%{_sysconfdir}/courier-imap/pop3d-ssl.dist.tmp

mv %{buildroot}%{_sysconfdir}/courier-imap/pop3d-ssl.dist.tmp \
        %{buildroot}%{_sysconfdir}/courier-imap/pop3d-ssl.dist

sed 's/^TLS_CERTFILE=.*/TLS_CERTFILE=\/etc\/courier-imap\/pop3d.pem/' \
        <%{buildroot}%{_sysconfdir}/courier-imap/pop3d-ssl.dist \
        >%{buildroot}%{_sysconfdir}/courier-imap/pop3d-ssl.dist.tmp

mv %{buildroot}%{_sysconfdir}/courier-imap/pop3d-ssl.dist.tmp \
	%{buildroot}%{_sysconfdir}/courier-imap/pop3d-ssl.dist

chmod 600 %{buildroot}%{_sysconfdir}/courier-imap/pop3d.dist
chmod 600 %{buildroot}%{_sysconfdir}/courier-imap/pop3d-ssl.dist

# Compress everything in man...

find %{buildroot}%{_mandir} ! -type d -print | %{__perl} -e '

	while (<>)
	{
		chop if /\n$/;
		next if /\.gz$/;
		$file=$_;
		if ( -l $file)
		{
                        symlink readlink("$file")
                                . ".gz", "$file.gz";
			unlink($file);
                }
                else
                {
                        system("gzip <$file >$file.gz");
			unlink($file);
		}
	}
'

# Create config files for sysconftool-rpmupgrade (see below)...

install -d %{buildroot}%{_datadir}/courier-imap
install -m 755 sysconftool %{buildroot}%{_datadir}/courier-imap/sysconftool

cat >%{buildroot}%{_datadir}/courier-imap/configlist <<EOF
%{_sysconfdir}/courier-imap/imapd.dist
%{_sysconfdir}/courier-imap/imapd-ssl.dist
%{_sysconfdir}/courier-imap/pop3d.dist
%{_sysconfdir}/courier-imap/pop3d-ssl.dist
EOF

cp -f /dev/null %{buildroot}%{_datadir}/courier-imap/configlist.ldap
cp -f /dev/null %{buildroot}%{_datadir}/courier-imap/configlist.mysql
cp -f /dev/null %{buildroot}%{_datadir}/courier-imap/configlist.pgsql

chmod 644 %{buildroot}%{_datadir}/courier-imap/configlist*

## Ok, upgrades are going to get ugly.  Because we install $filename.dist
## instead of $filename, and the old package has $filename listed as a config,
## RPM will back up $filename to $filename.rpmsave.  This will happen AFTER
## we will run the post scripts, effectively blowing away our configurations.
## PUT THEM BACK BY RUNNING THE FOLLOWING SCRIPT FROM A TRIGGER.

cat >%{buildroot}%{_datadir}/courier-imap/sysconftool-rpmupgrade <<EOF
#!/bin/sh

for f in \$* "."
do
	if test \$f = "."
	then
		continue
	fi

	base=\`echo \$f | sed 's/\\.dist\$//'\`
	if test -f \$base.dist -a ! -f \$base
	then
		%{__cp} -pr \$base.dist \$base
	fi
done
EOF

chmod 755 %{buildroot}%{_datadir}/courier-imap/sysconftool-rpmupgrade

# Check if authdaemond was installed, make sure to include authdaemon
# directory

cp /dev/null authdaemon.files

. authlib/authdaemonrc

if test "$authdaemonvar" != ""
then

	echo "%{_sysconfdir}/courier-imap/authdaemonrc.dist" >> %{buildroot}%{_datadir}/courier-imap/configlist
	echo "%{_sysconfdir}/courier-imap/authdaemonrc.dist" >> authdaemon.files
	echo '%dir %attr(700, root, root) ' $authdaemonvar >> authdaemon.files

	touch %{buildroot}/$authdaemonvar/lock || exit 1
	touch %{buildroot}/$authdaemonvar/pid || exit 1

	authlib/authmksock %{buildroot}/$authdaemonvar/socket || exit 1
	chmod 777 %{buildroot}/$authdaemonvar/socket || exit 1

	echo '%ghost %attr(600, root, root)' $authdaemonvar/lock >> authdaemon.files
	echo '%ghost %attr(644, root, root)' $authdaemonvar/pid >> authdaemon.files
	echo '%ghost %attr(-, root, root)' $authdaemonvar/socket >> authdaemon.files

fi

(cd %{buildroot} ; find .%{_libexecdir} -type f ! -name authdaemond.ldap ! -name authdaemond.mysql ! -name authdaemond.pgsql -print ) | cut -c2- >> authdaemon.files

cp /dev/null authdaemon.files.ldap
cp /dev/null authdaemon.files.mysql
cp /dev/null authdaemon.files.pgsql

test ! -f %{buildroot}%{_libexecdir}/authlib/authdaemond.mysql ||
	echo %{_libexecdir}/authlib/authdaemond.mysql >> authdaemon.files.mysql

test ! -f %{buildroot}%{_libexecdir}/authlib/authdaemond.pgsql ||
        echo %{_libexecdir}/authlib/authdaemond.pgsql >> authdaemon.files.pgsql

test ! -f %{buildroot}%{_libexecdir}/authlib/authdaemond.ldap || \
	echo %{_libexecdir}/authlib/authdaemond.ldap >> authdaemon.files.ldap

if test -f %{buildroot}%{_libexecdir}/authlib/authdaemond.mysql
then
	echo %{_sysconfdir}/courier-imap/authmysqlrc.dist >> %{buildroot}%{_datadir}/courier-imap/configlist.mysql
	echo %{_sysconfdir}/courier-imap/authmysqlrc.dist >> authdaemon.files.mysql
fi

if test -f %{buildroot}%{_libexecdir}/authlib/authdaemond.pgsql
then
        echo %{_sysconfdir}/courier-imap/authpgsqlrc.dist >> %{buildroot}%{_datadir}/courier-imap/configlist.pgsql
        echo %{_sysconfdir}/courier-imap/authpgsqlrc.dist >> authdaemon.files.pgsql
fi

if test -f %{buildroot}%{_libexecdir}/authlib/authdaemond.ldap
then
	echo %{_sysconfdir}/courier-imap/authldaprc.dist >> %{buildroot}%{_datadir}/courier-imap/configlist.ldap
	echo %{_sysconfdir}/courier-imap/authldaprc.dist >> authdaemon.files.ldap

	if test -d /etc/openldap/schema
	then
		mkdir -p %{buildroot}/etc/openldap/schema
		cp authlib/authldap.schema %{buildroot}/etc/openldap/schema/courier.schema
		echo '%config(noreplace) %attr(644, root, root) /etc/openldap/schema/courier.schema' >> authdaemon.files.ldap
	fi
fi

mkdir -p %{buildroot}%{_localstatedir}
touch %{buildroot}%{_localstatedir}/imapd.pid
touch %{buildroot}%{_localstatedir}/imapd-ssl.pid
touch %{buildroot}%{_localstatedir}/imapd.pid.lock
touch %{buildroot}%{_localstatedir}/imapd-ssl.pid.lock

touch %{buildroot}%{_localstatedir}/pop3d.pid
touch %{buildroot}%{_localstatedir}/pop3d-ssl.pid
touch %{buildroot}%{_localstatedir}/pop3d.pid.lock
touch %{buildroot}%{_localstatedir}/pop3d-ssl.pid.lock

%post
/sbin/chkconfig --add courier-imap
%{_datadir}/courier-imap/sysconftool `cat %{_datadir}/courier-imap/configlist` >/dev/null


%post ldap
%{_datadir}/courier-imap/sysconftool `cat %{_datadir}/courier-imap/configlist.ldap` >/dev/null

%post mysql
%{_datadir}/courier-imap/sysconftool `cat %{_datadir}/courier-imap/configlist.mysql` >/dev/null

%post pgsql
%{_datadir}/courier-imap/sysconftool `cat %{_datadir}/courier-imap/configlist.pgsql` >/dev/null

%preun ldap
%{_libexecdir}/imapd.rc stop
%{_libexecdir}/imapd-ssl.rc stop
%{_libexecdir}/pop3d.rc stop
%{_libexecdir}/pop3d-ssl.rc stop

%preun mysql
%{_libexecdir}/imapd.rc stop
%{_libexecdir}/imapd-ssl.rc stop
%{_libexecdir}/pop3d.rc stop
%{_libexecdir}/pop3d-ssl.rc stop

%preun pgsql
%{_libexecdir}/imapd.rc stop
%{_libexecdir}/imapd-ssl.rc stop
%{_libexecdir}/pop3d.rc stop
%{_libexecdir}/pop3d-ssl.rc stop

%preun

if test "$1" = "0"
then
	/sbin/chkconfig --del courier-imap
fi

%{_libexecdir}/imapd.rc stop
%{_libexecdir}/imapd-ssl.rc stop
%{_libexecdir}/pop3d.rc stop
%{_libexecdir}/pop3d-ssl.rc stop

%triggerpostun -- courier-imap

test ! -f %{_datadir}/courier-imap/configlist || %{_datadir}/courier-imap/sysconftool-rpmupgrade `cat %{_datadir}/courier-imap/configlist` >/dev/null

%triggerpostun ldap -- courier-imap-ldap

test ! -f %{_datadir}/courier-imap/configlist.ldap || %{_datadir}/courier-imap/sysconftool-rpmupgrade `cat %{_datadir}/courier-imap/configlist.ldap` >/dev/null

%triggerpostun mysql -- courier-imap-mysql

test ! -f %{_datadir}/courier-imap/configlist.mysql || %{_datadir}/courier-imap/sysconftool-rpmupgrade `cat %{_datadir}/courier-imap/configlist.mysql` >/dev/null

# pgsql was born after sysconftool

%clean
rm -rf %{buildroot}

%files -f authdaemon.files
%defattr(-, root, root)
%attr(644, root, root) %config /etc/pam.d/imap
%attr(644, root, root) %config /etc/pam.d/pop3
%attr(755, root, root) %{_initscriptdir}/courier-imap
%dir %{_libexecdir}/authlib
%dir %{_sysconfdir}/courier-imap
%config %{_sysconfdir}/courier-imap/imap*
%config %{_sysconfdir}/courier-imap/pop3*
%attr(644, root, root) %config %{_sysconfdir}/courier-imap/quotawarnmsg.example
%{_bindir}/*
%{_sbindir}/*
%{_mandir}/man?/*
%{_datadir}/courier-imap

%doc AUTHORS COPYING COPYING.GPL INSTALL
%doc NEWS README README.imap README.maildirquota
%doc README.sharedfolders imap/BUGS imap/ChangeLog
%doc authlib/README.*

%ghost %attr(600, root, root) %{_localstatedir}/imapd.pid
%ghost %attr(600, root, root) %{_localstatedir}/imapd-ssl.pid
%ghost %attr(600, root, root) %{_localstatedir}/imapd.pid.lock
%ghost %attr(600, root, root) %{_localstatedir}/imapd-ssl.pid.lock
%ghost %attr(600, root, root) %{_localstatedir}/pop3d.pid
%ghost %attr(600, root, root) %{_localstatedir}/pop3d-ssl.pid
%ghost %attr(600, root, root) %{_localstatedir}/pop3d.pid.lock
%ghost %attr(600, root, root) %{_localstatedir}/pop3d-ssl.pid.lock

%files ldap -f authdaemon.files.ldap
%defattr(-, root,root)

%files mysql -f authdaemon.files.mysql
%defattr(-, root, root)

%files pgsql -f authdaemon.files.pgsql
%defattr(-, root, root)

%changelog
* Mon Apr 25 2005 Toru Hoshina <t@momonga-linux.org>
- (3.0.7-2m)
- rebuild against postgresql-8.0.2.

* Tue Aug 26 2004 Mitsuru Shimamura <smbd@momonga-linux.org>
- (3.0.7-1m)
- up to 3.0.7
- change URL
- revise %doc

* Fri Jul  9 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.0.5-3m)
- add BuildRequires: momonga-rpmmacros >= 20040310-6m

* Sat Jul  3 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0.5-2m)
- stop daemon

* Tue Jun 15 2004 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- (3.0.5-1m)
- update to 3.0.5

* Fri Apr 2 2004 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- (3.0.3-1m)
- update to 3.0.3
- inludes major security fix

* Sat Feb 14 2004 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- (2.2.1-1m)
- update to 2.2.1

* Mon Nov 10 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.0-3m)
- rebuild against openldap

* Wed Sep  3 2003 YONEKAWA Susumu <yonekawa@mmg.roka.jp>
- (2.0.0-2m)
- rebuild against for MySQL-4.0.14-1m

* Fri Jul  4 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.0.0-1m)
  update to 2.0.0

* Thu Jun 19 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.7.3-2m)
  rebuild against cyrus-sasl2
  
* Tue May 27 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.7.3-1m)
  update to 1.7.3

* Tue Apr 08 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.7.1-2m)
- rebuild against zlib 1.1.4-5m

* Sat Mar 22 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.7.1-1m)
  update to 1.7.1

* Thu Mar  6 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.7.0-4m)
  rebuild against openssl 0.9.7a

* Mon Feb 10 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (1.7.0-3m)
- rebuild against for gdbm

* Fri Feb  7 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.7.0-2m)
  rebuild against libgdbm.

* Fri Jan 31 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.7.0-1m)
  update to 1.7.0
  set _libexecdir to /usr/libexec/courier-imap

* Thu Jan 23 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (1.5.3.20020823-5m)
- rebuild against for postgresql

* Wed Dec  4 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (1.5.3.20020823-4m)
- put source into cvs repo

* Fri Nov 22 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (1.5.3.20020823-3m)
- define bindir in courier-imap.sysvinit.in for some subscripts

* Sat Nov  9 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (1.5.3.20020823-2m)
- add gcc31 patch

* Mon Aug 26 2002 Kikutani Makoto <poo@momonga-linux.org>
- (1.5.3.20020823-1m)
- new upstream version

* Thu Jul 25 2002 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.5.1.20020715-1m)
  update to development version 1.5.1.20020715
  To Main

* Sun Jul  7 2002 Kazuhiko <kazuhiko@fdiary.net>
- (1.5.1-2m)
- '--without-authvchkpw'

* Wed Jul  3 2002 smbd <smbd@momonga-linux.org>
- (1.5.1-1m)
- up to 1.5.1

* Mon May 27 2002 Kazuhiko <kazuhiko@kondara.org>
- (1.4.6-2k)

* Tue May 14 2002 Masaru Sato <masachan@kondara.org>
- (1.4.5-2k)
- up to 1.4.5

* Wed Mar 13 2002 Tsutomu Yasuda <tom@kondara.org>
- (1.4.3-2k)
- update to 1.4.3

* Tue Jan  8 2002 Masaru Sato <masachan@kondara.org>
- (1.4.1-2k)
- up to 1.4.1

* Tue Dec 25 2001 Masaru Sato <masachan@kondara.org>
- (1.4.0-2k)
- up to 1.4.0

* Sat Nov 24 2001 Masaru Sato <masachan@kondara.org>
- (1.3.12-2k)
- up to 1.3.12
- enable PostgreSQL support

* Wed Oct 31 2001 Masaru Sato <masachan@kondara.org>
- (1.3.11-4k)
- cleanup and modify spec file
